#!/bin/bash
#This shell script is run once a day from cron
#It is used to backup all files on this machine
#It is used to backup files from this machine to a seperate tape within the Library, It backs up the directories listed in a file called everything in the root directory using Tar....The MTX part simply loads a tape for which ever day is required and removes that tape and places it back in it's slot in the library when finished. Please allow enuf time for this to happen, as some robotics are quite slow.
#Copyright "Nah" But please send me a note if you use or modify this for the better :-)
#made by Antony L Platt <antony@elizatravel.com>
#Eliza Travel Pty Ltd, P.O.Box 15195 Frankston, Victoria, 3199, Australia
#Ph +61 3 9783 3488 Fx +61 3 9783 4399
#
#
DAY=`(set \`date\`;echo $1)`
DATE=`(set \`date\`;echo $3)`
MONTH=`(set \`date\`;echo $2)`
YEAR=`(set \`date\`;echo $6)`
#SMONTH is the numerical version of a month eg 09 instead of Sep
SMONTH=
#LMONTH is the long version of a month name eg September instead of Sep
LMONTH=

#assign the variable LMONTH the long name of the month

case $MONTH in
  Jan)
        LMONTH=January
        SMONTH=01
        ;;
  Feb)
        LMONTH=February
        SMONTH=02
        ;;
  Mar)
        LMONTH=March
        SMONTH=03
        ;;
  Apr)
        LMONTH=April
        SMONTH=04
        ;;
  May)
        LMONTH=May
        SMONTH=05
        ;;
  Jun)
        LMONTH=June
        SMONTH=06
        ;;
  Jul)
        LMONTH=July
        SMONTH=07
        ;;
  Aug)
        LMONTH=August
        SMONTH=08
        ;;
  Sep)
        LMONTH=September
        SMONTH=09
        ;;
  Oct)
        LMONTH=October
        SMONTH=10
        ;;
  Nov)
        LMONTH=November
        SMONTH=11
        ;;
  Dec)
        LMONTH=December
        SMONTH=12
        ;;
  *)
esac

#This first part sets up who we will email this information to
(
echo "To: Tony Platt <antony@drivetravel.com>"
echo "Cc: Tony <sales@drivetravel.com>"
echo "From: Grumpy - Eliza Travel <postmaster>"
echo "Subject: Mondays Backup Run Finished - $DAY $DATE $LMONTH $YEAR"
echo

export PATH=/sbin:/usr/sbin:/bin:/usr/bin:

echo "This email was AutoMagically generated"
echo "by <<< Grumpy Backup Tape Server >>> at Eliza Travel"
echo
date
echo
date | cat > /tmp/start-date

#Next write a file containing the date and time of the backup that is going to be done

cd /backup
rm -f rm Backup-*
touch Backup-Done-$DAY-$DATE-$SMONTH-$YEAR

#Load the Mondays tape to the drive (Load Slot 1 in Drive)
mtx -f /dev/sg2 load 1
#Wait 1min for it to load
sleep 60

#Change to the / directory and backup all files to the tape drive echoing the output to a file in the temp directory called tar.output

cd /
tar -vcf /dev/st1 `cat everything` | cat > /tmp/tar.output

#Echo the outputs to the email
echo "Backup started"
echo
cat /tmp/start-date
echo
echo "Total No of files backed up"
cd /tmp
wc -l /tmp/tar.output > /tmp/file-count
echo
gawk '{print $1}' /tmp/file-count
echo
date | cat > /tmp/end-date
echo "Backup Finished"
echo
cat /tmp/end-date
echo
echo "   <<< -------- WARNING !!!------- >>>"
echo
echo " Backed up to Tape in DLT Library Slot 1 (Monday), Tape for tomorrow will be Slot 2 !!! "
echo
echo "Sundays are alternated between Slot 7 and Slot 8"
echo
echo
echo "<---Generated by Grumpy Backup Server at Eliza Travel--->"

cd /tmp
cp tar.output /backup/tape-list/files-on-tape-$DAY-$DATE-$MONTH-$YEAR
rm tar.output
rm -f file-count*
rm end-date
rm start-date
#Unload Mondays Tape from the drive back to it's slot in the autoloader
mtx -f /dev/sg2 unload 1

#Wait 30secs for it to unload
sleep 30

#This part rotates the two sunday scripts, to allow for the 2 different Sunday tapes
cd /root/backup_scripts
mv sunday-backup.sh sunday-backup.sh-old
mv 2ndsunday-backup.sh sunday-backup.sh
mv sunday-backup.sh-old 2ndsunday-backup.sh

) 2>&1 | /usr/lib/sendmail -t
exit 0
