#!/bin/bash
#This shell script is run once a day from cron
#It is used to retreive files via Samba from the "BOX" (see below), it walks down the shares and uses sambatar to Tar the files on this host for later archiving....Just change the name of the "BOX" below for the different hosts. And or add different shares available on that host.
#Copyright "Nah" But made by Antony L Platt <antony@elizatravel.com>
#Eliza Travel Pty Ltd, P.O.Box 15195 Frankston, Victoria, 3199, Australia
#Ph +61 3 9783 3488 Fx +61 3 9783 4399
#
#
#Define all variables here
#
#Host Name
BOX="tony"
#
#SMB Shares on above host
ADD="address"
FAV="favorites"
DOC="mydocs"
MAIL="mail"
#Place and name to write the tar files
ADDTAR="/backup/$BOX/$ADD.tar"
FAVTAR="/backup/$BOX/$FAV.tar"
DOCTAR="/backup/$BOX/$DOC.tar"
MAILTAR="/backup/$BOX/$MAIL.tar"
#Other Global Variables
DAY=`(set \`date\`;echo $1)`
DATE=`(set \`date\`;echo $3)`
MONTH=`(set \`date\`;echo $2)`
YEAR=`(set \`date\`;echo $6)`
#SMONTH is the numerical version of a month eg 09 instead of Sep
SMONTH=
#LMONTH is the long version of a month name eg September instead of Sep
LMONTH=
#assign the variable LMONTH the long name of the month

case $MONTH in
  Jan)
	LMONTH=January
	SMONTH=01
	;;
  Feb)
	LMONTH=February
	SMONTH=02
	;;
  Mar)
	LMONTH=March
	SMONTH=03
	;;
  Apr)
	LMONTH=April
	SMONTH=04
	;;
  May)
	LMONTH=May
	SMONTH=05
	;;
  Jun)
	LMONTH=June
	SMONTH=06
	;;
  Jul)
	LMONTH=July
	SMONTH=07
	;;
  Aug)
	LMONTH=August
	SMONTH=08
	;;
  Sep)
	LMONTH=September
	SMONTH=09
	;;
  Oct)
	LMONTH=October
	SMONTH=10
	;;
  Nov)
	LMONTH=November
	SMONTH=11
	;;
  Dec)
	LMONTH=December
	SMONTH=12
	;;
  *)
esac

#This first part sets up who we will email this information to, change to suite
(
echo "To: Antony Platt <antony@drivetravel.com>"
echo "From: Grumpy - Eliza Travel <postmaster>"
echo "Subject: $BOX's File Retreival Run Finished - $DAY $DATE $LMONTH $YEAR"
echo

export PATH=/sbin:/usr/sbin:/bin:/usr/bin:

echo "This email was AutoMagically generated"
echo "by <<<--Grumpy Backup Tape Server-->>>"
echo "<<<--------at Eliza Travel-------->>>"
echo
#Write a start date to a tempory file
date | cat > /tmp/start-date
echo
#Check and see if the host is up using "net cat" and has netbios "port 139" is open for connection

nc -v -z $BOX.eliza-travel.office 139
if [ "$?" -ne 0 ]
then
	#If not complain $BOX "host" unavailable and quit
	echo "Couldn't connect to $BOX.....probably not turned on.....No File retreivals today sorry.....quiting"
	exit 1 # Set retreival scripts exit status to 1
fi

#If host is up continue on, use smbtar to pull all the shares below on "host" Machine, then smbtar to this machines folder /backup/"hostname" to a file named after the share eg favorites.tar

#Echo the outputs to the email
echo "<-------File Retreival Started------->"
#Echo back the start time we wrote to the tempory file
cat /tmp/start-date
echo
echo "<---Retreival from $BOX to Grumpy Backup Server-Eliza Travel--->"
echo
echo "<---Got Connection to $BOX.....Retreiving Files--->"
echo
#Start the retreivals using smbtar
#"-s" is the host name
#"-x" is the share name
#"-t" is the tar file to write it to.
echo "============================"
echo
echo "Retreiving $BOX's $ADD Share"
smbtar -s $BOX -x $ADD -t $ADDTAR
echo
echo "============================"
echo
echo "Retreiving $BOX's $FAV Share"
smbtar -s $BOX -x $FAV -t $FAVTAR
echo
echo "============================"
echo
echo "Retreiving $BOX's $DOC Share"
smbtar -s $BOX -x $DOC -t $DOCTAR
echo
echo "============================"
echo
echo "Retreiving $BOX's $MAIL Share"
smbtar -s $BOX -x $MAIL -t $MAILTAR
echo
echo "============================"
echo
echo "<---Generated by Grumpy Backup Server at Eliza Travel--->"
echo
#finish and mail the outputs above.
) 2>&1 | /usr/lib/sendmail -t
exit 0
